
// This file is part of SPart, Spatially Located Workload Partitioner.

// Copyright (C) 2011, The Ohio State University
// SPart developed by Erdeniz O. Bas, Erik Saule and Umit V. Catalyurek 

// For questions, comments, suggestions, bugs please send e-mail to: 
// Umit V. Catalyurek   catalyurek.1@osu.edu

// SPart is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later
// version.

// SPart is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.

// You should have received a copy of the GNU General Public License
// along with SPart; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

// The full text of the GPL license version 2 is available in "gpl.txt".

#include "oned/greedy_bisect.hpp"
#include <iostream>


int main()
{
  using namespace oned;
  double w1[] = {0,1,3,6,10,15,21,28,36,45,55};
  double w2[] = {0,5,30,56,66,70,75,80,100,101};
  int w1cuts[] = {5,7,8,9}, w2cuts[] = {2,3};
  int w1res[4];
  int w2res[2];
  int w1size = 11, w2size=10, i;
  double b1= 15, b1found, b2=45, b2found;
  b1found = GreedyBisection<double, double* >::greedy_bisection(5, w1, w1size, w1res, -1.);
  if(b1found != b1)
    {
      std::cerr<<"error in greedy bisect 5 processors bottlencek found " <<b1found <<std::endl;
      return -1;
    }
  for(i = 0; i < 4; i++)
    if(w1res[i] != w1cuts[i])
      {
	std::cerr<<"error in greedy bisect 5 processors bottlencek found "<< b1found <<std::endl;
	return -1;
      }
  b2found = GreedyBisection<double, double* >::greedy_bisection(3, w2, w2size, w2res, -1.);
  if(b2found != b2)
    {
      std::cerr<<"error in greedy bisect 3 processors bottlencek found "<< b1found <<std::endl;
      return -1;
    }
  for(i = 0; i < 2; i++)
    if(w2res[i] != w2cuts[i])
      {
	std::cerr<<"error in greedy bisect 3 processors bottlencek found "<< b1found <<std::endl;
	return -1;
      }
  return 0;
}
