
// This file is part of SPart, Spatially Located Workload Partitioner.

// Copyright (C) 2011, The Ohio State University
// SPart developed by Erdeniz O. Bas, Erik Saule and Umit V. Catalyurek 

// For questions, comments, suggestions, bugs please send e-mail to: 
// Umit V. Catalyurek   catalyurek.1@osu.edu

// SPart is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later
// version.

// SPart is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.

// You should have received a copy of the GNU General Public License
// along with SPart; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

// The full text of the GPL license version 2 is available in "gpl.txt".

#include "util/rect_list.hpp"
#include "util/prefix_sum_tools.hpp"
#include <iostream>

int main()
{
  using namespace util;
  rectangle r;
  int array[9][9], i, j;
  for(i=0;i<9;i++)
    for(j=0;j<9;j++)
      array[i][j]=10*i+j;
  Prefix2D<double> prefixSum(9,9,array);
  RectList<double,Prefix2D<double> > rl1(prefixSum);
  r.x_top_l = 1;
  r.y_top_l = 1;
  r.x_bot_r = 4;
  r.y_bot_r = 4;
  rl1.add_rect(r);
  if(rl1.valid_part())
    {
      std::cerr << "Partition validation error in rl1" << std::endl;
      return -1;
    }
  r.x_top_l = 1;
  r.y_top_l = 5;
  r.x_bot_r = 4;
  r.y_bot_r = 9;
  rl1.add_rect(r);
if(rl1.valid_part())
    {
      std::cerr << "Partition validation error in rl1" << std::endl;
      return -1;
    }
  r.x_top_l = 5;
  r.y_top_l = 1;
  r.x_bot_r = 9;
  r.y_bot_r = 4;
  rl1.add_rect(r);
  if(rl1.valid_part())
    {
      std::cerr << "Partition validation error in rl1" << std::endl;
      return -1;
    }
  r.x_top_l = 5;
  r.y_top_l = 5;
  r.x_bot_r = 9;
  r.y_bot_r = 9;
  rl1.add_rect(r);
  if(!rl1.valid_part())
    {
      std::cerr << "Partition validation error in rl1" << std::endl;
      return -1;
    }
  RectList<double,Prefix2D<double> > rl2(prefixSum);
  r.x_top_l = 1;
  r.y_top_l = 1;
  r.x_bot_r = 9;
  r.y_bot_r = 9;
  rl2.add_rect(r);
  if(!rl2.valid_part())
    {
      std::cerr << "Partition validation error in rl1" << std::endl;
      return -1;
    }
  r.x_top_l = 4;
  r.y_top_l = 3;
  r.x_bot_r = 7;
  r.y_bot_r = 7;
  rl2.add_rect(r);
  if(rl2.valid_part())
    {
      std::cerr << "Partition validation error in rl1" << std::endl;
      return -1;
    }
  RectList<double,Prefix2D<double> > rl3(prefixSum);
  r.x_top_l = 1;
  r.y_top_l = 1;
  r.x_bot_r = 9;
  r.y_bot_r = 8;
  rl2.add_rect(r);
  if(rl2.valid_part())
    {
      std::cerr << "Partition validation error in rl1" << std::endl;
      return -1;
    }
  r.x_top_l = 1;
  r.y_top_l = 8;
  r.x_bot_r = 9;
  r.y_bot_r = 9;
  rl2.add_rect(r);
  if(rl2.valid_part())
    {
      std::cerr << "Partition validation error in rl1" << std::endl;
      return -1;
    }
  return 0;
}
