
// This file is part of SPart, Spatially Located Workload Partitioner.

// Copyright (C) 2011, The Ohio State University
// SPart developed by Erdeniz O. Bas, Erik Saule and Umit V. Catalyurek 

// For questions, comments, suggestions, bugs please send e-mail to: 
// Umit V. Catalyurek   catalyurek.1@osu.edu

// SPart is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later
// version.

// SPart is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.

// You should have received a copy of the GNU General Public License
// along with SPart; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.


// The full text of the GPL license version 2 is available in "gpl.txt".

#include "oned/uniform.hpp"
#include "util/prefix_sum_tools.hpp"
#include <iostream>
int main()
{
  using namespace oned;
  using namespace util;
  double input[] = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
  double pre[16];
  prefixsum<double>(input,pre,15);
  int *cutIn = new int[3];
  double max = Uniform<double, double*>::uni_cut(4,pre,16,cutIn,0);
  assert(cutIn[0]==3);
  assert(cutIn[1]==7);
  assert(cutIn[2]==11);
  assert(max==54);
  delete[] cutIn;
  cutIn = new int[4];
  max= Uniform<double, double*>::uni_cut(5,pre,16,cutIn,0);
  assert(cutIn[0]==3);
  assert(cutIn[1]==6);
  assert(cutIn[2]==9);
  assert(cutIn[3]==12);
  assert(max==42);
  delete[] cutIn;
  return 0;
}
