
// This file is part of SPart, Spatially Located Workload Partitioner.

// Copyright (C) 2011, The Ohio State University
// SPart developed by Erdeniz O. Bas, Erik Saule and Umit V. Catalyurek 

// For questions, comments, suggestions, bugs please send e-mail to: 
// Umit V. Catalyurek   catalyurek.1@osu.edu

// SPart is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later
// version.

// SPart is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.

// You should have received a copy of the GNU General Public License
// along with SPart; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.

// The full text of the GPL license version 2 is available in "gpl.txt".

#include "twod/uniform_2d.hpp"
#include <iostream>

int main()
{
  using namespace twod;
  using namespace util;
  double array2[10][10];
  int i,j;
  double result;
  for(i=0;i<10;i++)
    for(j=0;j<10;j++)
      array2[i][j]=10*i+j;
  
  Prefix2D<double> prefixSum2(10,10,array2);
  {
    RectList<double,Prefix2D<double> > rl1(prefixSum2);
    Uniform<double,Prefix2D<double> > foo;
    result = foo.part(25, prefixSum2, rl1);
    if(!rl1.valid_part() || (result != 374))
      {
	std::cerr<< "Error in uniform partitioning 1" << std::endl;
	return -1;
      }
  }

  {
    RectList<double,Prefix2D<double> > rl2(prefixSum2);
    Uniform<double,Prefix2D<double> > foo;
    result = foo.part(4, prefixSum2, rl2);
    if(!rl2.valid_part() || (result != 1925))
      {
	std::cerr<< "Error in uniform partitioning 2" << std::endl;
	return -1;
      }
  }
  return 0;
}
